# ==================================================================
# Plugins::GMail::ClamAV_Attach_Scan - Auto Generated Program Module
#
#   Plugins::GMail::ClamAV_Attach_Scan
#   Author  : Charlie
#   Version : 1.000
#   Updated : Tue Jul 13 02:20:25 2004
#
# ==================================================================
#

package Plugins::GMail::ClamAV_Attach_Scan;
# ==================================================================

use strict;
use GT::Base;
use GT::Plugins qw/STOP CONTINUE/;
use GMail qw/$IN $CFG $USER/;

# Inherit from base class for debug and error methods
@Plugins::GMail::ClamAV_Attach_Scan::ISA = qw(GT::Base);

# Your code begins here! Good Luck!
use lib "$CFG->{location}->{path}->{admin}/Plugins/GMail/ClamAV_Attach_Scan";


# PLUGIN HOOKS
# ===================================================================


sub scan {
# -----------------------------------------------------------------------------
# This subroutine will be called whenever the hook 'GMail::EmailAttach::upload' is run.  You
# should call GT::Plugins->action(STOP) if you don't want the regular
# 'GMail::EmailAttach::upload' code to run, otherwise the code will continue as normal.
#
  my ($message, $file) = @_;

  my $attach_id = $IN->param('attach_id') or die "No attach ID.";
  $attach_id =~ /^([\w\-. ]+)$/ and $attach_id = $1;
  
  $file ||= $IN->param('attach_filename');
  $file or return __PACKAGE__->error('ATTACHERR_NOFILE', 'FATAL');
  my $data_dir = "$USER->{dir}/upload/$attach_id";
  my ($safe_file, $read, $buffer);

  # Windows C:\
  $file =~ s/^\s*\w\:[\/\\]//;

  # File path removal for linux/windows/mac
  if ($file =~ /([\\\/\:])/) { $file = substr($file, rindex($file, $1) + 1) }

  $safe_file = $IN->escape($file);

  # Copy IN to the server in the users upload directory
  my $to_scan = "$data_dir/$safe_file";

  require File::Scan::ClamAV;
  my $av = File::Scan::ClamAV->new(port => '/var/run/clamav/clamd');
  if($av->ping){
    if(-f $to_scan){
      my $data;
      if(open(my $fh, $to_scan)){
        local $/;
        $data = <$fh>;
        close($fh);
      } else { die "Unable to read file: $to_scan $!\n"; }

      my ($code, $virus) = $av->streamscan($data);
      if($code eq 'OK'){ return @_; }
      elsif($code eq 'FOUND'){
        $message->{message} = "The attachment: $file contained the virus: $virus";
        unlink $to_scan or __PACKAGE__->error('VIRUS_DELETE', 'WARN', $to_scan, $!);
        return $message;
      }
      else { die $av->errstr; }
    } else { die "Unknown file: $file\n"; }
  }
  
  return $message, $file;
}

# ADMIN MENU OPTIONS
# ===================================================================

sub info {
# -------------------------------------------------------------------
# This subroutine will get called whenever the user clicks on 'Info' in the
# admin menu.  Remember, you need to print your own content-type headers; you
# should use:
#
  print $IN->header();
  print "Info goes here :)";
}

# Always end with a 1.
1;
