# ==================================================================
# Plugins::GMail::ClamAV_Attach_Scan - Auto Generated Install Module
#
#   Plugins::GMail::ClamAV_Attach_Scan
#   Author  : Charlie
#   Version : 1.000
#   Updated : Tue Jul 13 02:20:25 2004
#
# ==================================================================
#

package Plugins::GMail::ClamAV_Attach_Scan;
# ==================================================================
use strict;
use vars  qw/$VERSION $DEBUG $NAME $META/;
use GT::Base;
use GT::Plugins qw/STOP CONTINUE/;
use GMail qw/$IN $DB $CFG/;

$VERSION = '1.000';
$DEBUG   = 0;
$NAME    = 'ClamAV_Attach_Scan';
# Inhert from base class for debug and error methods
@Plugins::GMail::ClamAV_Attach_Scan::ISA = qw(GT::Base);

$META = {
    'url' => 'http://www.x2concepts.com/',
    'description' => 'Scan all attachments with ClamAV virus scanner.',
    'author' => 'Charlie Piper',
    'license' => 'Freeware',
    'version' => '1.000',
    'prog_ver' => '2.2.3-Upgrade'
};


sub pre_install {
# -----------------------------------------------------------------------------
# This function displays an HTML formatted message that will display any
# instructions/information to the user before they install the plugin.
#
    return 'You are about to install the ClamAV Attachemnt Scan Plugin.';
}

sub pre_uninstall {
# -----------------------------------------------------------------------------
# This function displays an HTML formatted message that will display any
# instructions/information to the user before they remove the plugin.
#
    return 'You are about to uninstall the ClamAV Attachemnt Scan Plugin.';
}

sub install {
# -----------------------------------------------------------------------------
# This function does the actual installation.  Its first argument is a plugin
# manager which you can use to register hooks, install files, add menu options,
# etc.  The second argument is a GT::Tar object which you can use to access any
# files in your plugin module.
#
# You should return an HTML formatted string that will be displayed to the
# user.
#
# If there is an error, return undef, and set the error message in
# $Plugins::GMail::ClamAV_Attach_Scan::error
#
    my ($mgr, $tar) = @_;
    
    $mgr->install_hooks('ClamAV_Attach_Scan', [['GMail::Email::Attach::upload', 'POST', 'Plugins::GMail::ClamAV_Attach_Scan::scan', 'FIRST']]);
    $mgr->install_menu('ClamAV_Attach_Scan', [['Info', 'admin.cgi?do=plugin&plugin=ClamAV_Attach_Scan&func=info']]);

# Silence warnings
    $GT::Tar::error ||= '';

# The following section will unarchive attached files into the proper location.
    my $file;

# Copying File/Scan/ClamAV.pm to $CFG->{location}->{path}->{admin} directory.
    $file = $tar->get_file('File/Scan/ClamAV.pm');
    $file->name("$CFG->{location}->{path}->{admin}/Plugins/GMail/ClamAV_Attach_Scan/File/Scan/ClamAV.pm");
    $file->write or return Plugins::GMail::ClamAV_Attach_Scan->error("Unable to extract file '$CFG->{location}->{path}->{admin}/Plugins/GMail/ClamAV_Attach_Scan/File/Scan/ClamAV.pm': $GT::Tar::error", 'WARN');

    # Install code here;
    return "The ClamAV Attachment Scan Plugin has been successfully installed!";
}

sub uninstall {
# -----------------------------------------------------------------------------
# This function removes the plugin.  Its first argument is also a plugin
# manager which you can use to register hooks, install files, add menu options,
# etc. You should return an HTML formatted string that will be displayed to the
# user.
#
# If there is an error, return undef, and set the error message in
# $Plugins::GMail::ClamAV_Attach_Scan::error
#
    my $mgr = shift;
    
    $mgr->uninstall_hooks('ClamAV_Attach_Scan', [['GMail::Email::Attach::upload', 'POST', 'Plugins::GMail::ClamAV_Attach_Scan::scan', 'FIRST']]);
    $mgr->uninstall_menu('ClamAV_Attach_Scan', [['Info', 'admin.cgi?do=plugin&plugin=ClamAV_Attach_Scan&func=info']]);
    # Uninstall code here;

    return "The ClamAV Attachment Scan Plugin has been successfully removed!";
}

1;
